      PROGRAM CALC_RL
      !
      ! CALCULATES RADIATION LENGTHS
      !
      CHARACTER LINE*150, MAT*13,UNIT*2,WORT
      REAL    T,R,X0,C,WM(26)
      INTEGER NUM,INDF,Z,A
      CHARACTER CONFIG*4
      !LOGICAL OSCAR
      
      PARAMETER(PF=0.55)
      PARAMETER(CONFIG='PERP')
      !OSCAR=.FALSE.

      IOUT=99
      !-------------------------------------------------------------------

      IF(CONFIG.EQ.'PARA') THEN
        OPEN(UNIT=11,FILE= "in/nh3_para.lis",STATUS="old")
        OPEN(UNIT=99,FILE="out/nh3_para.out",STATUS="unknown")
      ELSEIF(CONFIG.EQ.'PERP') THEN
        OPEN(UNIT=11,FILE= "in/nh3_perp.lis",STATUS="old")
        OPEN(UNIT=99,FILE="out/nh3_perp.out",STATUS="unknown")
      ELSE
        STOP "PROBLEM"
      ENDIF

      WRITE(IOUT,'(A3,A13,2A3,A8,X,A2,4A7,A2)') " ","   ","Z","A","T","    ",
     & "g/cm3","X0","g/cm2","RL(%)","  "
      WRITE(IOUT,'(A61)')'--------------------------------------------'


      !-------------------------------------------------------------------

      SUMBEF = 0
      SUMAFT = 0
      SUM    = 0
 
 100  CONTINUE
      READ(11,'(A)',END=200) LINE
      IF(LINE(1:1).EQ.'#') GOTO 100

      READ(LINE,*,ERR=200) NUM, MAT, TU, UNIT, R, X0, C, WORT, XZ, XA, WM_IN, INDF
      Z=INT(XZ)
      A=INT(XA)
      WM(NUM) = WM_IN
      IF(UNIT.EQ."in") THEN
        T = TU*2.54 
      ELSEIF (UNIT.EQ."cm") THEN
        T = TU
      ELSE
        WRITE(6,*) "Unit Problem: ",UNIT
        STOP
      ENDIF

      FACTOR = 1.0 
      
      IF (WORT.EQ.'t') THEN         ! Target material
        FACTOR = 1.0
        IF(NUM.EQ.13) THEN          ! Helium
          FACTOR = (1.0-PF)
        ELSE
          !FACTOR = C/4.0 * PF
           IF (NUM.EQ. 9) FACTOR = 15.000/(18.024)* 0.98 *PF
           IF (NUM.EQ.10) FACTOR =  3.024/(18.024)* 0.98 *PF
           IF (NUM.EQ.11) FACTOR = 14.000/(17.027)* 0.02 *PF
           IF (NUM.EQ.12) FACTOR =  3.024/(17.027)* 0.02 *PF
        ENDIF
      ENDIF

      GCM2 = T * R      * FACTOR        ! grams/cm^2
      RL   = T * R / X0 * FACTOR

      !IF(OSCAR) THEN
      !  IF( (NUM.LE.2) .OR. (NUM.GE.22) ) RL=0.0 
      !ENDIF


      WRITE(IOUT,'((I2,X),A,2I3,F8.4,X,A,3F7.3,F7.2)') NUM,MAT,Z,A,TU,UNIT,R,X0,GCM2,RL*100.0

      SUM = SUM + RL

      IF(NUM.LT.9) THEN
        SUMBEF = SUMBEF + RL
      ELSEIF(NUM.LT.14) THEN
        SUMBEF = SUMBEF + RL/2.
        SUMAFT = SUMAFT + RL/2.
      ELSEIF(NUM.EQ.14 .OR. NUM.EQ.15) THEN
        SUMBEF = SUMBEF + RL/2.
        SUMAFT = SUMAFT + RL/2.
      ELSEIF(NUM.LE.24) THEN
        SUMAFT = SUMAFT + RL
      ELSE
        WRITE(6,'(A)') "Problem" 
      ENDIF

      GOTO 100
 200  CONTINUE

      WRITE(IOUT,*)
      WRITE(IOUT,'(A,A10)')   "Configuration    : ",CONFIG
      WRITE(IOUT,'(A,F10.2)') "Packing Fraction : ",PF
      WRITE(IOUT,'(A,F10.2)') "TOTAL            : ",SUM*100.0
      WRITE(IOUT,'(A,F10.2)') "BEFORE           : ",SUMBEF*100.0
      WRITE(IOUT,'(A,F10.2)') "AFTER            : ",SUMAFT*100.0

      END
